



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>[转]linux shell 多线程实现</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">[转]linux shell 多线程实现</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-26 06:02:27 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>情景</h1>
<p>shell脚本的执行效率虽高，但当任务量巨大时仍然需要较长的时间，尤其是需要执行一大批的命令时。因为默认情况下，shell脚本中的命令是串行执行的。如果这些命令相互之间是独立的，则可以使用&ldquo;并发&rdquo;的方式执行这些命令，这样可以更好地<strong>利用系统资源，提升运行效率，缩短脚本执行的时间</strong>。如果命令相互之间存在交互，则情况就复杂了，那么不建议使用shell脚本来完成多线程的实现。</p>
<p>为了方便阐述，使用一段测试代码。在这段代码中，通过<code>seq</code>命令输出1到10，使用<code>for...in</code>语句产生一个执行10次的循环。每一次循环都执行<code>sleep 1</code>，并<code>echo</code>出当前循环对应的数字。</p>
<p>注意：</p>
<ol><li>真实的使用场景下，循环次数不一定等于10，或高或低，具体取决于实际的需求。</li>
<li>真实的使用场景下，循环体内执行的语句往往比较耗费系统资源，或比较耗时等。</li></ol>
<p><strong>请根据真实场景的各种情况理解本文想要表达的内容</strong>。</p>
<pre class="prettyprint linenums"><code>$ cat test1.sh  </code></pre>
<pre class="prettyprint linenums"><code>#/bin/bash

all_num=10

a=$(date +%H%M%S)

for num in `seq 1 ${all_num}`<br />
do<br />
    sleep 1<br />
    echo ${num}<br />
done

b=$(date +%H%M%S)

echo -e "startTime:\t$a"<br />
echo -e "endTime:\t$b"<br />
</code></pre>
<p>通过上述代码可知，为了体现执行的时间，将循环体开始前后的时间打印了出来。</p>
<p>运行结果：</p>
<pre class="prettyprint linenums"><code>$ sh test1.sh </code></pre>
<pre class="prettyprint linenums"><code>1<br />
2<br />
3<br />
4<br />
5<br />
6<br />
7<br />
8<br />
9<br />
10<br />
startTime:  193649<br />
endTime:    193659<br />
</code></pre>
<p>10次循环，每次sleep 1秒，所以总执行时间10s。</p>
<h2>方案</h2>
<h3>方案1：使用"&amp;"使命令后台运行</h3>
<p>在linux中，在命令的末尾加上<code>&amp;</code>符号，则表示该命令将在后台执行，这样后面的命令不用等待前面的命令执行完就可以开始执行了。示例中的循环体内有多条命令，则可以以<code>{}</code>括起来，在大括号后面添加<code>&amp;</code>符号。</p>
<pre class="prettyprint linenums"><code>$ cat test2.sh </code></pre>
<pre class="prettyprint linenums"><code>#/bin/bash

all_num=10

a=$(date +%H%M%S)

for num in `seq 1 ${all_num}`<br />
do<br />
{<br />
    sleep 1<br />
    echo ${num}<br />
} &amp;<br />
done

b=$(date +%H%M%S)

echo -e "startTime:\t$a"<br />
echo -e "endTime:\t$b"<br />
</code></pre>
<p>运行结果：</p>
<pre class="prettyprint linenums"><code>sh test2.sh </code></pre>
<pre class="prettyprint linenums"><code>startTime:  194147<br />
endTime:    194147<br />
[j-tester@merger142 ~/bin/multiple_process]$ 1<br />
2<br />
3<br />
4<br />
5<br />
6<br />
7<br />
8<br />
9<br />
10<br />
</code></pre>
<p>通过结果可知，程序没有先打印数字，而是直接输出了开始和结束时间，然后显示出了命令提示符<code>[j-tester@merger142 ~/bin/multiple_process]$</code>（出现命令提示符表示脚本已运行完毕），然后才是数字的输出。这是因为循环体内的命令全部进入后台，所以均在sleep了1秒以后输出了数字。开始和结束时间相同，即循环体的执行时间不到1秒钟，这是由于循环体在后台执行，没有占用脚本主进程的时间。</p>
<h3>方案2：命令后台运行+<code>wait</code>命令</h3>
<p>解决上面的问题，只需要在上述循环体的done语句后面加上<code>wait</code>命令，该命令等待当前脚本进程下的子进程结束，再运行后面的语句。</p>
<pre class="prettyprint linenums"><code>$ cat test3.sh </code></pre>
<pre class="prettyprint linenums"><code>#/bin/bash

all_num=10

a=$(date +%H%M%S)

for num in `seq 1 ${all_num}`<br />
do<br />
{<br />
    sleep 1<br />
    echo ${num}<br />
} &amp;<br />
done

wait

b=$(date +%H%M%S)

echo -e "startTime:\t$a"<br />
echo -e "endTime:\t$b"<br />
</code></pre>
<p>运行结果：</p>
<pre class="prettyprint linenums"><code>$ sh test3.sh </code></pre>
<pre class="prettyprint linenums"><code>1<br />
2<br />
3<br />
4<br />
5<br />
6<br />
7<br />
9<br />
8<br />
10<br />
startTime:  194221<br />
endTime:    194222<br />
</code></pre>
<p>但这样依然存在一个问题：<br /> 因为<code>&amp;</code>使得所有循环体内的命令全部进入后台运行，那么倘若循环的次数很多，会使操作系统在瞬间创建出所有的子进程，这会非常消耗系统的资源。如果循环体内的命令又很消耗系统资源，则结果可想而知。</p>
<p>最好的方法是并发的进程是可配置的。</p>
<h3>方案3：使用文件描述符控制并发数</h3>
<pre class="prettyprint linenums"><code>$ cat test4.sh </code></pre>
<pre class="prettyprint linenums"><code>#/bin/bash

all_num=10<br />
# 设置并发的进程数<br />
thread_num=5

a=$(date +%H%M%S)

# mkfifo<br />
tempfifo="my_temp_fifo"<br />
mkfifo ${tempfifo}<br />
# 使文件描述符为非阻塞式<br />
exec 6&lt;&gt;${tempfifo}<br />
rm -f ${tempfifo}

# 为文件描述符创建占位信息<br />
for ((i=1;i&lt;=${thread_num};i++))<br />
do<br />
{<br />
    echo<br />
}<br />
done &gt;&amp;6 

#<br />
for num in `seq 1 ${all_num}`<br />
do<br />
{<br />
    read -u6<br />
    {<br />
        sleep 1<br />
        echo ${num}<br />
        echo "" &gt;&amp;6<br />
    } &amp;<br />
}<br />
done 

wait

# 关闭fd6管道<br />
exec 6&gt;&amp;-

b=$(date +%H%M%S)

echo -e "startTime:\t$a"<br />
echo -e "endTime:\t$b"

</code></pre>
<p>运行结果：</p>
<pre class="prettyprint linenums"><code>$ sh test4.sh </code></pre>
<pre class="prettyprint linenums"><code>1<br />
3<br />
2<br />
4<br />
5<br />
6<br />
7<br />
8<br />
9<br />
10<br />
startTime:  195227<br />
endTime:    195229<br />
</code></pre>
<h3>方案4：使用<code>xargs -P</code>控制并发数</h3>
<p>xargs命令有一个<code>-P</code>参数，表示支持的最大进程数，默认为1。为0时表示尽可能地大，即<code>方案2</code>的效果。</p>
<pre class="prettyprint linenums"><code>$ cat test5.sh </code></pre>
<pre class="prettyprint linenums"><code>#/bin/bash

all_num=10<br />
thread_num=5

a=$(date +%H%M%S)

seq 1 ${all_num} | xargs -n 1 -I {} -P ${thread_num} sh -c "sleep 1;echo {}"

b=$(date +%H%M%S)

echo -e "startTime:\t$a"<br />
echo -e "endTime:\t$b"<br />
</code></pre>
<p>运行结果：</p>
<pre class="prettyprint linenums"><code>$ sh test5.sh<br />
</code></pre>
<pre class="prettyprint linenums"><code>1<br />
2<br />
3<br />
4<br />
5<br />
6<br />
8<br />
7<br />
9<br />
10<br />
startTime:  195257<br />
endTime:    195259<br />
</code></pre>
<h3>方案5：使用<code>GNU parallel</code>命令控制并发数</h3>
<p><code>GNU parallel</code>命令是非常强大的并行计算命令，使用<code>-j</code>参数控制其并发数量。</p>
<pre class="prettyprint linenums"><code>$ cat test6.sh </code></pre>
<pre class="prettyprint linenums"><code>#/bin/bash

all_num=10<br />
thread_num=6

a=$(date +%H%M%S)

parallel -j 5 "sleep 1;echo {}" ::: `seq 1 10`

b=$(date +%H%M%S)

echo -e "startTime:\t$a"<br />
echo -e "endTime:\t$b"<br />
</code></pre>
<p>运行结果：</p>
<pre class="prettyprint linenums"><code>$ sh test6.sh </code></pre>
<pre class="prettyprint linenums"><code>1<br />
2<br />
3<br />
4<br />
5<br />
6<br />
7<br />
8<br />
9<br />
10<br />
startTime:  195616<br />
endTime:    195618<br />
</code></pre>
<h2>总结</h2>
<p>&ldquo;多线程&rdquo;的好处不言而喻，虽然shell中并没有真正的多线程，但上述解决方案可以实现&ldquo;多线程&rdquo;的效果，重要的是，在实际编写脚本时应有这样的考虑和实现。<br /> 另外：<br /> 方案3、4、5虽然都可以控制并发数量，但方案3显然写起来太繁琐。<br /> 方案4和5都以非常简洁的形式完成了控制并发数的效果，但由于方案5的parallel命令非常强大，所以十分建议系统学习下。<br /> 方案3、4、5设置的并发数均为5，实际编写时可以将该值作为一个参数传入。</p>
<h3>参考文章</h3>
<ol><li><a href="http://blog.csdn.net/qq_34409701/article/details/52488964" rel="external nofollow noreferrer">http://blog.csdn.net/qq_34409701/article/details/52488964</a></li>
<li><a href="https://www.codeword.xyz/2015/09/02/three-ways-to-script-processes-in-parallel/" rel="external nofollow noreferrer">https://www.codeword.xyz/2015/09/02/three-ways-to-script-processes-in-parallel/</a></li>
<li><a href="http://www.gnu.org/software/parallel/" rel="external nofollow noreferrer">http://www.gnu.org/software/parallel/</a></li></ol>
<h3>相关知识点</h3>
<ul><ul><li>wait命令</li>
<li><code>&amp;</code>后台运行</li>
<li>文件描述符、mkfifo等</li>
<li>xargs命令</li>
<li>parallel命令</li></ul></ul>
<p>链接：https://www.cnblogs.com/signjing/p/7074778.html</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rqlpr219.html">import 本地Python module或package</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96430j8.html">gitlab&plus;gerrit&plus;jenkins持续集成框架</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql3zdkq.html">Unity3D使用Assetbundle打包加载（Prefab、场景）</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96rwny9.html">jquery注意</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j00ollq.html">HDU 4122</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zvevz9.html">集成Spring后HibernateTemplate实现分页</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd4r778.html">java实现附件预览（openoffice&plus;swftools&plus;flexpaper）</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vp1xo8.html">Oracle的学习一：安装与卸载、sql &ast;plus常用命令、Oracle用户管理</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0g0yeq.html">ZOJ 3603 Draw Something Cheat</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okm4419.html">Android模仿jquery异步请求</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1rvgxq.html">【转】Netty系列之Netty并发编程分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdwzvv9.html">多重if-else语句</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1jy3lq.html">dubbo 概述和使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvv2y38.html">Maven3-依赖</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j121k49.html">QtQuick大坑笔记之Http的Get与Post操作（带cookie）</a>
		</li>
						<li><a href="https://www.batexi.com/a/960k3jv9.html">编写前程贷投标loadrunner脚本及总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vm2j5q.html">JS设置状态栏</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emr5vm9.html">做题记录 To 2019&period;2&period;13</a>
		</li>
						<li><a href="https://www.batexi.com/a/qloe131q.html">12&period;MySQL必知必会之分组数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/9g3mmd4q.html">Docker搭建独立服务器</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q7o535x8.html">数组&amp;lt&semi;--&amp;gt&semi;变量</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxd3x3e9.html">php实现队列</a>
			</li>
						<li><a href="https://www.batexi.com/a/960rkon9.html">1&period;numpy&lowbar;overview</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25zn1lq.html">20165309 实验一 Java开发环境的熟悉</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2565rq.html">【基础知识】【1】CDN</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pw4ojy8.html">Leetcode 999&period; 车的可用捕获量</a>
			</li>
						<li><a href="https://www.batexi.com/a/960rwkj9.html">java前后向查找个人理解</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdwy2o79.html">前端基础之html常用标签</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gj7ozz9.html">MySQL变量变更小记</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m25142q.html">使用Intellij中的Spring Initializr来快速构建Spring Boot&sol;Cloud工程（十五）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
